﻿using MyTrelloWeb.App.AppServices;
using MyTrelloWeb.VCommon.Ioc;
using MyTrelloWeb.VCommon.Json;
using MyTrelloWeb.VCommon.Logging;
using MyTrelloWeb.VCommon.VOpenApi;
using System;
using System.Collections.Generic;
using System.Web;

namespace MyTrelloWeb.App
{
    public class ApiModule : ApiModuleBase
    {
        public ApiModule() : base("MyTrello", "dev", "/api", new Dictionary<string, Type>
        {
            {"Kanban", typeof(IKanbanService)},
        }, "http", "https")
        {
        }

        protected override object ResolveService(Type intrefaceType) => IocManager.Instance.Resolve(intrefaceType);

        protected override void ErrorHandle(Exception exception)
        {
            Logger.Error("ApiModule: exception during invoke service", exception);

            //400:业务层面错误 FriendlyException

            HttpContext.Current.Response.ContentType = "application/json";
            if (exception is VFriendlyException fex)
            {
                HttpContext.Current.Response.StatusCode = 400;
                HttpContext.Current.Response.Write(VJsonSerializer.Serialize(new { fex.Message }));
            }
            else
            {
                base.ErrorHandle(exception);
            }
        }
    }
}
