﻿using MyTrelloWeb.App.Auditing;
using MyTrelloWeb.App.EntityFramework;
using MyTrelloWeb.VCommon.Ioc;
using MyTrelloWeb.VCommon.Linq.Expressions.Predicate;
using MyTrelloWeb.VCommon.VApplication;
using MyTrelloWeb.VCommon.VEntity;

namespace MyTrelloWeb.App.AppServices.Common
{
    internal class AppServiceBase : ApplicationServiceBase, ITransientIocClass<IServiceAuditInterceptor>
    {
        // db

        protected MyTrelloDataContext GetDbContext() => IocManager.Instance.Resolve<MyTrelloDataContext>();

        protected VAppEfRepository<MyTrelloDataContext, TEntnty> GetRepository<TEntnty>(params string[] disableFilters) where TEntnty : VEntityBase
        {
            var repository = new VAppEfRepository<MyTrelloDataContext, TEntnty>();
            foreach (var name in disableFilters) repository.DisableFilter(name);
            return repository;
        }
    }

    internal abstract class AppServiceBase<TEntity> : AppServiceBase where TEntity : VEntityBase
    {
        // repos

        protected VAppEfRepository<MyTrelloDataContext, TEntity> GetRepository(params string[] disableFilters) => GetRepository<TEntity>(disableFilters);

        // query expression shortcuts

        protected static readonly PredicateBuilder<TEntity> PredicateBuilder = PredicateBuilder<TEntity>.Instance;
    }
}