﻿using FluentMigrator;
using MyTrelloWeb.VCommon.Logging;

namespace MyTrelloWeb.App.DbMigration
{
    [Migration(Version)]
    public class RenameTitleToName : Migration
    {
        private const long Version = 20190414214400;

        public override void Up()
        {
            Logger.Info($"Exec Migration UP {Version}_{GetType().Name}");

            Rename
                .Column("Title").OnTable("Kanban").To("Name");
        }

        public override void Down()
        {
            Logger.Info($"Exec Migration DOWN {Version}_{GetType().Name}");

            Rename
                .Column("Name").OnTable("Kanban").To("Title");
        }
    }
}