﻿using MySql.Data.Entity;
using MyTrelloWeb.App.Entity;
using MyTrelloWeb.VCommon.Logging;
using MyTrelloWeb.VCommon.VApplication;
using System.Data.Entity;
using System.Text;

namespace MyTrelloWeb.App.EntityFramework
{
    [DbConfigurationType(typeof(MySqlEFConfiguration))]
    public partial class MyTrelloDataContext : VAppDbContextBase
    {
        //Define tables here

        public IDbSet<KanbanEntity> Kanban { get; set; }

        //Define views here
        //End of scheme define
        partial void InitDevEnv();

        public MyTrelloDataContext() : base(MyTrelloConfig.DefaultConnectionString)
        {
            InitDevEnv();
            Database.SetInitializer<MyTrelloDataContext>(null);
        }

        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            modelBuilder.HasDefaultSchema(""); //MySQL TRICK
            base.OnModelCreating(modelBuilder);
        }
    }

#if DEBUG

    public partial class MyTrelloDataContext
    {
        private StringBuilder _output = new StringBuilder();

        partial void InitDevEnv()
        {
            Database.Log = s =>
            {
                _output.Append(s);
                System.Diagnostics.Debug.WriteLine(s);
            };
        }

        protected override void Dispose(bool disposing)
        {
            base.Dispose(disposing);
            Logger.Debug("SQL in EF", _output.ToString());
        }
    }

#endif
}
