﻿using System.Linq;

namespace MyTrelloWeb.App.EntityFramework
{
    public static class QueryableExtensionMethod
    {
        public static T FirstOrThrowNotFound<T>(this IQueryable<T> queryable, string objectName = null)
        {
            var array = queryable.Take(1).ToArray();
            if (0 == array.Length)
            {
                throw new VFriendlyException(string.IsNullOrEmpty(objectName)
                    ? "找不到对象" //TODO：Attribute on entity for friend  object name
                    : $"找不到{objectName}");
            }
            return array[0];
        }
    }
}
