﻿using MyTrelloWeb;
using System;
using System.Configuration;
using MyTrelloWeb.VCommon.Logging;

[assembly: WebActivatorEx.PreApplicationStartMethod(typeof(LoggerActivator), nameof(LoggerActivator.InitLogger), Order = int.MinValue)]
[assembly: WebActivatorEx.ApplicationShutdownMethod(typeof(LoggerActivator), nameof(LoggerActivator.QuitLogger), Order = int.MaxValue)]

namespace MyTrelloWeb
{
    public class LoggerActivator
    {
        public static void InitLogger()
        {
            Logger.Init(new VJsonFileLogger(logTo: ConfigurationManager.AppSettings["LogPath"], enableAll: true)); //TODO: 稳定之后把ALL日志关闭?
            Logger.Info("Logger Init");
#if DEBUG
            Logger.EnableDebugLevel = true;
            Logger.Info("Enable debug level");
#endif
            AppDomain.CurrentDomain.UnhandledException += (sender, e) => { Logger.Fatal("AppDomain.CurrentDomain.UnhandledException", e.ExceptionObject); };
        }

        public static void QuitLogger()
        {
            Logger.Info("Application Quit");
        }
    }
}
