﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace MyTrelloWeb.VCommon.DataAnnotations.ExtraValidation
{
    public class NoEmptyGuid : ValidationAttribute
    {
        public NoEmptyGuid() : base("{0} is required and can not be empty")
        {

        }

        protected override ValidationResult IsValid(object value, ValidationContext validationContext)
        {
            return value is Guid guid && Guid.Empty == guid
                ? new ValidationResult(FormatErrorMessage(validationContext.DisplayName),
                    new[] { validationContext.MemberName })
                : null;
        }
    }
}