﻿using System;
using System.Collections.Generic;
using MyTrelloWeb.VCommon.Logging;

namespace MyTrelloWeb.VCommon.VApplication.Auditing.Json
{
    public abstract class JsonApplicationServiceAuditInterceptorBase : ApplicationServiceAuditInterceptorBase
    {
        private static readonly JsonAuditLogSerializer JsonSerializer = new JsonAuditLogSerializer();

        //TODO: 需要授权再打开
        //protected JsonApplicationServiceAuditInterceptorBase(IVSession session) : base(session)
        //{
        //}

        private static string TryJsonSerialize(object obj)
        {
            try
            {
                return JsonSerializer.SerializeObject(obj);
            }
            catch (Exception e)
            {
                Logger.Error("Audit json serialize fail", e);
                return JsonSerializer.SerializeObject(obj?.ToString());
            }
        }

        protected override void WriteAuditLog(DateTime time, long msUsed, Guid? tenantId, Guid? userId, string serviceClassName, string serviceMethodName, IReadOnlyDictionary<string, object> input, object output, object exception)
        {
            WriteJsonAuditLog(time, msUsed, tenantId, userId, serviceClassName, serviceMethodName,
                JsonSerializer.SerializeObject(input),
                JsonSerializer.SerializeObject(output),
                TryJsonSerialize(exception));
        }

        protected abstract void WriteJsonAuditLog(DateTime time, long msUsed, Guid? tenantId, Guid? userId, string serviceClassName, string serviceMethodName, string input, string output, string exception);
    }
}