﻿using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;
using EntityFramework.DynamicFilters;
using MyTrelloWeb.VCommon.Ioc;
using MyTrelloWeb.VCommon.VEntity;
using MyTrelloWeb.VCommon.VEntityFramework;

namespace MyTrelloWeb.VCommon.VApplication
{
    public abstract class VAppDbContextBase : VEfDbContextBase, ITransientIocClass
    {
        //TODO: 需要授权再开
        //[Dependency]
        //public IVSession VrwSession { get; set; }

        protected VAppDbContextBase(string nameOrConnectionString) : base(nameOrConnectionString)
        {
            //TODO: 需要授权再开
            //this.SetFilterScopedParameterValue(VEfDataFilters.MustHaveTenant, () => VrwSession.TenantId);
            //this.SetFilterScopedParameterValue(VEfDataFilters.MayHaveTenant, () => VrwSession.TenantId);

            //if (IocManager.Instance.TryResolve<IOrgManager>(out var detect) && detect.Enabled)
            //{
            //    this.SetFilterScopedParameterValue(VEfDataFilters.MustHaveOrg, () =>
            //    {
            //        var orgManager = IocManager.Instance.Resolve<IOrgManager>();
            //        if (false == orgManager.Enabled)
            //        {
            //            DisableFilter(VEfDataFilters.MustHaveOrg);
            //            return Array.Empty<Guid>().WrapEnumerable();
            //        }

            //        var tid = VrwSession.TenantId;
            //        var uid = VrwSession.UserId;

            //        var r = uid.HasValue && tid.HasValue
            //            ? orgManager.GetUserVisionOrgs(tid.Value, uid.Value).WrapEnumerable()
            //            : Array.Empty<Guid>().WrapEnumerable();

            //        return r;
            //    });
            //}
            //else
            //{
            //    DisableFilter(VEfDataFilters.MustHaveOrg);
            //}
        }

        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            base.OnModelCreating(modelBuilder);
            modelBuilder.Filter(VEfDataFilters.MustHaveTenant, (IMustHaveTenant t, Guid tenantId) => t.TenantId == tenantId || (Guid?)t.TenantId == null, Guid.Empty); //While "(Guid?)t.TenantId == null" seems wrong, it's needed. See https://github.com/jcachat/EntityFramework.DynamicFilters/issues/62#issuecomment-208198058
            modelBuilder.Filter(VEfDataFilters.MayHaveTenant, (IMayHaveTenant t, Guid? tenantId) => t.TenantId == tenantId, (Guid?)null);
            modelBuilder.Filter(VEfDataFilters.MustHaveOrg, (IMustHaveOrg o, IEnumerable<Guid> orgIds) => orgIds.Contains(o.OrgId), Enumerable.Empty<Guid>());
        }

        public override int SaveChanges()
        {
            //TODO: 需要授权再开

            //if (IsFilterEnabled(VEfDataFilters.MustHaveTenant))
            //{
            //    foreach (var track in ChangeTracker.Entries<IMustHaveTenant>().Where(p => p.State == EntityState.Added)) track.Entity.TenantId = VrwSession.GetTenantId();
            //}

            //foreach (var track in ChangeTracker.Entries<IHaveCreationUserId>().Where(p => p.State == EntityState.Added)) track.Entity.CreationUserId = VrwSession.UserId ?? Guid.Empty;
            //foreach (var track in ChangeTracker.Entries<IHaveLastModificationUserId>().Where(p => p.State == EntityState.Modified)) track.Entity.LastModificationUserId = VrwSession.UserId;

            //foreach (var track in ChangeTracker.Entries<ISoftDelete>().Where(p => p.State == EntityState.Deleted))
            //{
            //    if (track.Entity is IHaveLastModificationUserId lmu) lmu.LastModificationUserId = VrwSession.UserId;
            //}

            return base.SaveChanges();
        }

        public override void EnableFilter(string filterName)
        {
            //TODO: 需要授权再开
            //if (VEfDataFilters.MustHaveOrg == filterName)
            //{
            //    if (false == IocManager.Instance.TryResolve<IOrgManager>(out var orgManager) || false == orgManager.Enabled)
            //        throw new InvalidOperationException("IOrgManager must resolvable and enable");
            //}

            base.EnableFilter(filterName);
        }
    }

    public interface IOrgManager
    {
    }
}