﻿using System;
using System.Data.Entity;
using System.Linq;
using System.Linq.Expressions;
using MyTrelloWeb.VCommon.VEntity;

namespace MyTrelloWeb.VCommon.VEntityFramework
{
    public static class VEfExtensionMethods
    {
        public static TEntity GetOrDefault<TEntity>(this IDbSet<TEntity> dbSet, Guid id) where TEntity : VEntityBase
        {
            return dbSet.FirstOrDefault(p => p.Id == id);
        }
        public static TEntity GetOrDefault<TEntity>(this IDbSet<TEntity> dbSet, Expression<Func<TEntity, bool>> filter) where TEntity : VEntityBase
        {
            return dbSet.FirstOrDefault(filter);
        }
    }
}