﻿using System;

namespace MyTrelloWeb.VCommon.VEntityFramework
{
    internal class FilterDisableState<TDbContext> : IDisposable where TDbContext : VEfDbContextBase
    {
        private readonly TDbContext _ctx;
        private readonly string _filterName;

        public FilterDisableState(TDbContext ctx, string filterName)
        {
            _ctx = ctx;
            _filterName = filterName;

            _ctx.DisableFilter(_filterName);
        }

        public void Dispose()
        {
            _ctx.EnableFilter(_filterName);
        }
    }
}
